# File generated from our OpenAPI spec by Stainless. See CONTRIBUTING.md for details.

from typing import List, Optional
from datetime import datetime

from .._models import BaseModel

__all__ = ["ChatSessionWithMessages", "Commit", "Message"]


class Commit(BaseModel):
    id: str

    chat_session_id: str

    commit_hash: str

    created_at: datetime


class Message(BaseModel):
    id: str

    chat_session_id: str

    content: str

    created_at: datetime

    role: str

    timestamp: datetime


class ChatSessionWithMessages(BaseModel):
    id: str

    commits: List[Commit]

    created_at: datetime

    git_application_token: str

    messages: List[Message]

    project_id: str

    updated_at: datetime

    user_id: str

    latest_workflow_session_id: Optional[str] = None
